"""
Capítulo 11.4.1.- Exercícios

Exercício 06 - Método alternativo de encontrar raizes

"""

#importando bibliotecas de funções 
import sys, math

#definindo a função f(x)
f = lambda x:  x ** 3 - x ** 2 - 13 * x + 8

a = float(input("Digite o valor do inicio do intervalo: ")) #inicio do intervalo
b = float(input("Digite o valor do final do intervalo: ")) #final do intervalo

if a > b:
	a = b #gante que b é o início do intervalo

erro = 1E-7

h = 0.1 #incremento inicial


while h >= erro: #ira realizar os incrementos somente dentro do intervalo

	c = a + h
	while f(a) * f(c) > 0:
		a = c
		c = a + h
	if f(c) == 0:
		break
	h /= 10

print('O valor da raiz é {:.7f}'.format(c))
		
'''
Este método converge para a solução de modo satisfatório, porém 
em questão de recurso computacional, este método consome muito mais
processamento, uma vez que realiza diversas operações até encontrar a
raiz. Se adicionarmos um iterador para contar as operações, este método
necessita de 60 iterações para convergir no intervalo [-2,2], contra 3
iterações no método de Newton-Raphson com x0 = 1 para a mesma função
'''

#Fim do programa
